﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace Turing
{
    public class Stan
    {
        private char stanGłowicy;
        private int położenieGłowicy;
        private string taśma;

        public char StanGłowicy
        {
            get
            {
                return stanGłowicy;
            }
        }

        public char StanKomórkiPodGłowicą
        {
            get
            {
                return taśma[położenieGłowicy];
            }
        }

        public Stan(char stanGłowicy, int położenieGłowicy, string taśma)
        {
            this.stanGłowicy = stanGłowicy;
            this.położenieGłowicy = położenieGłowicy;
            this.taśma = taśma;

            if (!char.IsLower(stanGłowicy)) throw new TuringException("Zły opis stanu głowicy");
            if (położenieGłowicy < 0 || położenieGłowicy >= taśma.Length) throw new TuringException("Niepoprawne położenie głowicy");
            //TODO: skopiowany kod!!!
            if (!taśma.All(c => char.IsUpper(c))) throw new TuringException("Niepoprawny format taśmy");
        }

        public static Stan Wczytaj(string ścieżkaPliku)
        {
            string tekst = File.ReadAllText(ścieżkaPliku);
            //if (tekst.Count((char c) => { return char.IsLower(c); }) != 1) throw new TuringException("Błędny format pliku stanu maszyny - nieodpowiednia liczba znaków oznaczających stan głowicy");
            if (tekst.Count(c => char.IsLower(c)) != 1) throw new TuringException("Błędny format pliku stanu maszyny - nieodpowiednia liczba znaków oznaczających stan głowicy");            
            char stanGłowicy = tekst.First(c => char.IsLower(c));
            int położenieGłowicy = tekst.IndexOf(stanGłowicy);
            string taśma = tekst.Substring(0, położenieGłowicy) + tekst.Substring(położenieGłowicy + 1);
            if (!taśma.All(c => char.IsUpper(c))) throw new TuringException("Niepoprawny format taśmy");
            return new Stan(stanGłowicy, położenieGłowicy, taśma);
        }

        public override string ToString()
        {
            return taśma.Insert(położenieGłowicy, stanGłowicy.ToString());
        }
    }
}
